Asterisk.org: Developer Documentation (28 Oct 2009)

Wed Oct 28 15:49:12 2009

## Asterisk developer's documentation

# privacy.c File Reference

Privacy Routines. More...

`#include <stdio.h>`
`#include <stdlib.h>`
`#include <string.h>`
`#include <sys/time.h>`
`#include <signal.h>`
`#include <errno.h>`
`#include <unistd.h>`
`#include <dirent.h>`
`#include "asterisk.h"`
`#include "asterisk/channel.h"`
`#include "asterisk/file.h"`
`#include "asterisk/app.h"`
`#include "asterisk/dsp.h"`
`#include "asterisk/logger.h"`
`#include "asterisk/options.h"`
`#include "asterisk/astdb.h"`
`#include "asterisk/callerid.h"`
`#include "asterisk/privacy.h"`
`#include "asterisk/utils.h"`
`#include "asterisk/lock.h"`

Include dependency graph for privacy.c:

Go to the source code of this file.

## Functions

int | ast_privacy_check (char *dest, char *cid)
int | ast_privacy_reset (char *dest)
int | ast_privacy_set (char *dest, char *cid, int status)

## Detailed Description

Privacy Routines.

Definition in file privacy.c.

## Function Documentation

int ast_privacy_check | ( | char * | dest,
|  | char * | cid |
| ) |  |  |

Definition at line 50 of file privacy.c.

References ast_callerid_parse(), ast_db_get(), AST_PRIVACY_ALLOW, AST_PRIVACY_DENY, AST_PRIVACY_KILL, AST_PRIVACY_TORTURE, AST_PRIVACY_UNKNOWN, ast_shrink_phone_number(), key(), n, and result.

Referenced by dial_exec_full().

    00051 {
    00052    char tmp[256] = "";
    00053    char *trimcid = "";
    00054    char *n, *l;
    00055    int res;
    00056    char key[256], result[256];
    00057    if (cid)
    00058       ast_copy_string(tmp, cid, sizeof(tmp));
    00059    ast_callerid_parse(tmp, &n, &l);
    00060    if (l) {
    00061       ast_shrink_phone_number(l);
    00062       trimcid = l;
    00063    }
    00064    snprintf(key, sizeof(key), "%s/%s", dest, trimcid);
    00065    res = ast_db_get("privacy", key, result, sizeof(result));
    00066    if (!res) {
    00067       if (!strcasecmp(result, "allow"))
    00068          return AST_PRIVACY_ALLOW;
    00069       if (!strcasecmp(result, "deny"))
    00070          return AST_PRIVACY_DENY;
    00071       if (!strcasecmp(result, "kill"))
    00072          return AST_PRIVACY_KILL;
    00073       if (!strcasecmp(result, "torture"))
    00074          return AST_PRIVACY_TORTURE;
    00075    }
    00076    return AST_PRIVACY_UNKNOWN;
    00077 }

int ast_privacy_reset | ( | char * | dest | ) |

Definition at line 79 of file privacy.c.

References ast_db_deltree().

    00080 {
    00081    if (!dest)
    00082       return -1;
    00083    return ast_db_deltree("privacy", dest);
    00084 }

int ast_privacy_set | ( | char * | dest,
|  | char * | cid,
|  | int | status |
| ) |  |  |

Definition at line 86 of file privacy.c.

References ast_callerid_parse(), ast_db_del(), ast_db_put(), AST_PRIVACY_ALLOW, AST_PRIVACY_DENY, AST_PRIVACY_KILL, AST_PRIVACY_TORTURE, AST_PRIVACY_UNKNOWN, ast_shrink_phone_number(), ast_strlen_zero(), key(), and n.

Referenced by dial_exec_full().

    00087 {
    00088    char tmp[256] = "";
    00089    char *trimcid = "";
    00090    char *n, *l;
    00091    int res;
    00092    char key[256];
    00093    if (cid)
    00094       ast_copy_string(tmp, cid, sizeof(tmp));
    00095    ast_callerid_parse(tmp, &n, &l);
    00096    if (l) {
    00097       ast_shrink_phone_number(l);
    00098       trimcid = l;
    00099    }
    00100    if (ast_strlen_zero(trimcid)) {
    00101       /* Don't store anything for empty Caller*ID */
    00102       return 0;
    00103    }
    00104    snprintf(key, sizeof(key), "%s/%s", dest, trimcid);
    00105    if (status == AST_PRIVACY_UNKNOWN)
    00106       res = ast_db_del("privacy", key);
    00107    else if (status == AST_PRIVACY_ALLOW)
    00108       res = ast_db_put("privacy", key, "allow");
    00109    else if (status == AST_PRIVACY_DENY)
    00110       res = ast_db_put("privacy", key, "deny");
    00111    else if (status == AST_PRIVACY_KILL)
    00112       res = ast_db_put("privacy", key, "kill");
    00113    else if (status == AST_PRIVACY_TORTURE)
    00114       res = ast_db_put("privacy", key, "torture");
    00115    else
    00116       res = -1;
    00117    return res;
    00118 }